/*****************************************************************************/
/* galois.h								     */
/*****************************************************************************/

#ifndef	__GALOIS_H_INCLUDED
#define	__GALOIS_H_INCLUDED	1

/*****************************************************************************/

#include <stdint.h>

#define	galois_2p32_add(a,b)		((uint32_t)((a)^(b)))
#define	galois_2p32_sub(a,b)		((uint32_t)((a)^(b)))

uint32_t galois_2p32_mul(uint32_t a,uint32_t b);

#ifdef	__arm__
uint32_t galois_2p32_mul_asm(uint32_t a,uint32_t b);
void	 galois_2p32_mul_accumulate_2(uint32_t *acc,uint32_t *in,uint32_t b);
#endif

uint32_t galois_2p32_pow(uint32_t a,int nn);
uint32_t galois_2p32_div(uint32_t a,uint32_t b);
uint32_t galois_2p32_rcp(uint32_t b);
void	 galois_2p32_mul_cache_create(uint32_t *arr,uint32_t b);
uint32_t galois_2p32_mul_cached(uint32_t a,uint32_t *arr);


/*****************************************************************************/

#endif

/*****************************************************************************/
